#ifndef FOCUS_HANDLER_HPP
#define FOCUS_HANDLER_HPP

struct SDL_Rect;

namespace bwidgets::abstract
{
    class FocusHandler
    {
        protected:
            const SDL_Rect* _focus_area = nullptr;
            bool            _has_focus  = false;

            virtual void _handle_focus_change();

        public:
            virtual ~FocusHandler();

            inline virtual void focus(bool focus)
            {
                _has_focus = focus;
                _handle_focus_change();
            }
    };
}

#endif
