#ifndef KEYBOARD_HANDLER
#define KEYBOARD_HANDLER

#include <basic_widgets/abstract/focus_handler.hpp>

struct SDL_KeyboardEvent;
struct SDL_TextInputEvent;

namespace bwidgets::abstract
{
    class KeyboardHandler : public virtual FocusHandler
    {
        protected:

            virtual void _handle_key(const SDL_KeyboardEvent&);
            virtual void _handle_text_input(const SDL_TextInputEvent&);

        public:
            inline virtual void handle_keyboard(const SDL_KeyboardEvent& ev)
            {
                if (_has_focus)
                    _handle_key(ev);
            }

            inline virtual void handle_keyboard(const SDL_TextInputEvent& ev)
            {
                if (_has_focus)
                    _handle_text_input(ev);
            }
    };
}

#endif
