#ifndef LAYOUT_HPP
#define LAYOUT_HPP

#include <vector>

#include <basic_widgets/abstract/widget.hpp>

namespace bwidgets::abstract
{
    class Layout : public abstract::Widget
    {
        protected:
            std::vector<Widget*> _widgets;

            virtual void _update_layout() = 0;

        public:
            Widget::Size margins {4, 4};

            virtual ~Layout();
            virtual void add_widget(Widget*);
            virtual void handle_event(const SDL_Event&);
            virtual void render(SDL_Renderer*);
            virtual void viewport(const SDL_Rect&);

            virtual Widget::Size size() const = 0;
    };
}

#endif
