#ifndef WIDGET_HPP
#define WIDGET_HPP

#include <functional>

#include <SDL2/SDL_events.h>
#include <SDL2/SDL_rect.h>

struct SDL_Renderer;

namespace bwidgets::abstract
{
    class Widget
    {
        protected:
            SDL_Rect _viewport    {0, 0, 0, 0};
            SDL_Rect _widget_area {0, 0, 0, 0};

            virtual void _update_widget_area();

        public:
            struct Size {
                int w;
                int h;
            };

            Widget* parent;

            Widget(Widget* parent=nullptr);
            virtual ~Widget();

            virtual void handle_event(const SDL_Event&);
            virtual void render(SDL_Renderer*);
            virtual void viewport(const SDL_Rect&);

            inline virtual Size size() const
            {
                return {_widget_area.w, _widget_area.h};
            }
    };
}

#endif
