#ifndef BUTTON_HPP
#define BUTTON_HPP

#include <string>

#include <basic_widgets/abstract/mouse_handler.hpp>
#include <basic_widgets/caption.hpp>

namespace bwidgets::widget
{
    class Button : public abstract::Widget,
                   public abstract::FontHandler,
                   public abstract::MouseHandler
    {
        protected:
            widget::Caption _caption;
            SDL_Rect        _caption_area;
            float           _caption_height_multiplicator {1.2};
            SDL_Color       _color_foreground             {0, 0, 0, SDL_ALPHA_OPAQUE};

            void _handle_font_change();
            void _update_widget_area();

        public:
            int       border_width   {3};
            SDL_Color color_bg       {150, 150, 150, SDL_ALPHA_OPAQUE};
            SDL_Color color_bg_hover {175, 175, 175, SDL_ALPHA_OPAQUE};

            Button(Widget* parent=nullptr);

            void                   render(SDL_Renderer*);
            abstract::Widget::Size size() const;
            const std::string&     text() const;
            void                   text(std::string);
    };
}

#endif
