#ifndef DRAWING_PRIMITIVE
#define DRAWING_PRIMITIVE

#include <functional>

#include <SDL2/SDL_pixels.h>
#include <SDL2/SDL_rect.h>
#include <SDL2/SDL_render.h>

struct SDL_Texture;

namespace bwidgets::utils::render
{
    SDL_Color aa(const SDL_Color&&, const int, const float);

    SDL_Texture* filled_circle(const SDL_Color&,
                               int resolution,
                               SDL_Renderer*,
                               int aa_pixels = 5);
    void         set_pixels_color(SDL_Texture*, std::function<Uint32 (const SDL_Point&,
                                                                      const SDL_PixelFormat*)>);

    static inline int render_copy(SDL_Renderer* r, SDL_Texture* t, SDL_Rect dst)
    {
        return SDL_RenderCopy(r, t, NULL, &dst);
    }

    static inline int render_copy(SDL_Renderer* r, SDL_Texture* t, SDL_Rect src, SDL_Rect dst)
    {
        return SDL_RenderCopy(r, t, &src, &dst);
    }
}

#endif
