#include <basic_widgets/horizontal_layout.hpp>

using namespace bwidgets;

abstract::Widget::Size widget::Horizontal_Layout::size() const
{
    abstract::Widget::Size max {0, 0};

    for (const auto* w : _widgets)
    {
        if (w->size().w > max.w)
            max.w = w->size().w;
        if (w->size().h > max.h)
            max.h = w->size().h;
    }

    return {
        (int)_widgets.size() * max.w + ((int)_widgets.size() + 1) * margins.w,
        max.h + 2 * margins.h
    };
}

void widget::Horizontal_Layout::_update_layout()
{
    int widget_size = (_viewport.w - (_widgets.size() + 1) * margins.w)
                      / _widgets.size();

    for (std::vector<Widget*>::size_type i = 0; i < _widgets.size(); i++)
    {
         _widgets.at(i)->viewport({
            _viewport.x + margins.w + (int)i * (widget_size + margins.w),
            _viewport.y + margins.h,
            widget_size - margins.w,
            _viewport.h - margins.h
        });
    }
}
