#include <SDL2/SDL_render.h>

#include <basic_widgets/abstract/layout.hpp>

using namespace bwidgets;

abstract::Layout::~Layout()
{
    for (Widget* widget_ptr : _widgets)
        delete widget_ptr;
}

void abstract::Layout::add_widget(Widget *widget_ptr)
{
    _widgets.push_back(widget_ptr);
}

void abstract::Layout::handle_event(const SDL_Event& ev)
{
    for (Widget* widget_ptr : _widgets)
        widget_ptr->handle_event(ev);
}

void abstract::Layout::render(SDL_Renderer* r)
{
    SDL_RenderSetViewport(r, &_viewport);

    for (Widget* widget_ptr : _widgets)
        widget_ptr->render(r);
}

void abstract::Layout::viewport(const SDL_Rect& vp)
{
    Widget::viewport(vp);
    _update_layout();
}
