#include <iostream>
#include <fontconfig/fontconfig.h>

#include <basic_widgets/utils/font.hpp>

namespace bwidgets::utils::font
{
    std::string find(const std::string& pat)
    {
        FcConfig* conf = FcInitLoadConfigAndFonts();

        FcPattern* pattern = FcNameParse((FcChar8*)pat.c_str());
        FcConfigSubstitute(conf, pattern, FcMatchPattern);
        FcDefaultSubstitute(pattern);

        bool found = false;
        std::string file_path;
        FcResult res;
        FcPattern* font = FcFontMatch(conf, pattern, &res);
        if (font != nullptr)
        {
            FcChar8* file = nullptr;
            if (FcPatternGetString(font, FC_FILE, 0, &file) == FcResultMatch)
            {
                file_path = (char*)file;
                found = true;
            }
            FcPatternDestroy(font);
        }
        FcConfigDestroy(conf);
        FcFini();

        if (!found)
            throw exception::NotFound();

        return file_path;
    }
}
