#include <basic_widgets/vertical_layout.hpp>

using namespace bwidgets;

abstract::Widget::Size widget::Vertical_Layout::size() const
{
    abstract::Widget::Size max {0, 0};

    for (const auto* w : _widgets)
    {
        if (w->size().w > max.w)
            max.w = w->size().w;
        if (w->size().h > max.h)
            max.h = w->size().h;
    }

    return {
        max.w + 2 * margins.w,
        (int)_widgets.size() * max.h + ((int)_widgets.size() + 1) * margins.h
    };
}

void widget::Vertical_Layout::_update_layout()
{
    int widget_size = (_viewport.h - (_widgets.size() + 1) * margins.h)
                      / _widgets.size();

    for (std::vector<Widget*>::size_type i = 0; i < _widgets.size(); i++)
    {
        SDL_Rect widget_vp = {
                _viewport.x + margins.w,
                _viewport.y + margins.h + (int)i * (widget_size + margins.h),
                _viewport.w - margins.w,
                widget_size - margins.h,
        };
        _widgets.at(i)->viewport(widget_vp);
    }
}
